<?php
/***************************************************************************
 * $Id: basis.class.php 56 2008-06-08 22:35:41Z Nico $
 * Part of Parsimony Import
 * inspired by parsimony_2_phpbb by Lex Alexander
 * (E-Mail: alexander.lex@gmx.at)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

include_once ( 'mysql.class.php' );
include_once ( 'xajax/xajax_core/xajaxAIO.inc.php' );

class basisImport {
	var $POST_START = "<!-- Anfang BeitragsText -->";
	var $POST_END = "<!-- Ende BeitragsText -->";
	var $TITLE_BEGIN = "<!-- Ende BeitragsNavigationsLeisteOben -->";
	var $RESPONSES =  "(<!--responses:";
	 
	var $actualTopicID = null;
	var $lastPosting = null;	
	var $insertedTopics = 0;
	var $insertedPosts = 0;
	var $filesToParse = array();
	var $actualParsedFile = null;
	var $parentTopic = array();
	
	var $debugMode = false;
	var $postingsToAdd, $postingsAlreadyAdded, $lastOutput = 0;
	var $useXAJAX, $hasAlert = false;

	var $directory, $xajaxResponse = null;

	function basisImport( $directory, $host, $user, $pass, $db, $useXAJAX = false, $debug = false ) {
		$this->debugMode = $debug;
		$this->useXAJAX = $useXAJAX;
		if ( $this->useXAJAX ) {
			$this->xajaxResponse = new xajaxResponse();
		}

		$this->database = new MySQL_class ( $host, $user, $pass, $db );
		
		if ( $this->database->error() ) {
			$this->alert ( $this->database->error() );
			return;
		}
		
		$this->database->sql_echo($debug);
		$this->directory = $directory;
		if ( substr ( $this->directory, -1, 0 ) != '/' ) {
			$this->directory .= DIRECTORY_SEPARATOR;
		}
		if ( $this->directory == null ) {
			$this->alert ( "No directory given" );
			return;
		}		
		$this->importDirectory ( $this->directory );
		
		natsort ( $this->filesToParse );
		
		$this->postingsToAdd = count ( $this->filesToParse );
	}
	
	function importDirectory ( $dirName )
	{
		if ( !( $dir = @opendir ( $dirName ) ) ) {
			$this->alert ( "Error on opening " . $dirName );
			return;
		}
		
		// start reading the whole directory for files
		while ( ( $file = readdir ( $dir ) ) !== false ) {
			if ( $file == "." || $file == ".." || $file == "index.htm" || substr ( $file, -4, 4 ) == ".dat" || $file == "zip.txt" ) {
				continue;
			}
			if ( is_dir ( $file ) ) {
				$this->importDirectory ( $dirName . DIRECTORY_SEPARATOR . $file );
			} else {
				$fileNumber = (int)str_replace ( '.htm', '', $file );
				if ( $fileNumber . '.htm' != $file ) {
					continue;
				}
				$this->filesToParse[$fileNumber] = $file;
			}
		}	
	}

	function checkTableExistance ( $name ) 
	{
		$sql = 'SHOW TABLES LIKE "' . $name . '"';
		$result = $this->database->sql_query ( $sql );
		if ( $this->database->sql_numrows ( $result ) < 1 ) {
			$this->alert ( 'Table <i>' . $name . '</i> not existing - abort' );
		}			
	}	
	 
	function doImport() {
		// import all postings
		$this->importPostings();	
		$this->finally();
	}
	
	function importPostings( $limit = -1 ) {
		if ( $limit == -1 ) {
			$limit = count ( $this->filesToParse ) + 100;
		}
		
		foreach ( $this->filesToParse as $actualFileToImport ) {
			// double-check to avoid problems if $this->filesToParse
			// is changed in the meantime
			if ( $limit <= 0 ) {
				return true;
			}
			
			if ( in_array ( $actualFileToImport, $this->filesToParse ) ) {
				$this->extract_new_thread( $actualFileToImport );
				$limit--;
			}
		}
		
	}
	
	// Extract a new thread whose root is located in $starting_file
	function extract_new_thread($starting_file)
	{
		$this->extract_message($starting_file);

		// ====== extract the references ======
		$file_name = $this->directory . $starting_file;
		$response_first_part =  file_get_contents($file_name, "r");
		 
		preg_match_all('/<!--responses: (.*?)-->/i', $response_first_part, $matches);
				
		foreach ( $matches[1] as $respons ) {
			// Save all answers. Do NOT directly import them to keep the right
			// structure in database
			$this->parentTopic[$respons . '.htm'] = $this->actualTopicID;
		}
	}

	// Extract a message form $origin_file_name
	function extract_message( $origin_file_name )
	{
		if ( !in_array ( $origin_file_name, $this->filesToParse ) ) {
			// Message is already imported
			return;
		}
		
		$file_name = $this->directory . $origin_file_name;
		set_time_limit ( 5 );
		$file = file_get_contents($file_name, "r");
		$this->actualParsedFile = $file_name;
		
		if ( strlen ( $file ) == 0 ) {
			// empty file, do not import
			$this->deleteFileFromTasklist($origin_file_name);
			return;
		}

		// ====== extract the title ======
		preg_match('/<input type=hidden name="origsubject" value="(.*)">/i', $file, $matches);
		$message_title = $matches[1];
		
		// ====== extract the date ======
		if (	preg_match('/<input type=hidden name="origdate" value="(.*)">/i', $file, $matches) == 0 &&
				preg_match('/<input type=hidden name="origdadate" value="(.*)">/i', $file, $matches) == 0 )
		 {
			$this->alert ( 'Was not able to extract posting date from ' . $this->actualParsedFile . ' - please contact the author!' );
		 }
		$postingTime = $this->convertToTimestamp ( $matches[1] );
		
		// ====== extract the poster ======
		preg_match('/<input type=hidden name="origname" value="(.*)">/i', $file, $matches);
		$posterName = $matches[1];		
		
		// ====== extract the message composed ======
		
		$messageSplitted = false;
		if ( preg_match('/<!-- Ende BeitragsNavigationsLeisteOben -->(.*?)<!-- AnfangLinie -->/is', $file, $matches) > 0 ) {
			$messageSplitted = explode ( "\n", $matches[1] );
		} else if ( preg_match('/<!-- AnfangLinie -->(.*?)<!-- EndeLinie -->(.*?)<!-- AnfangLinie -->(.*?)<!-- EndeLinie -->(.*?)<!-- AnfangLinie -->(.*?)<!-- EndeLinie -->/is', $file, $matches) > 0 ) {
			$messageSplitted = explode ( "\n", $matches[4] );
		}
		
		if ( $messageSplitted ) {
			// delete meta-text:
			if ( preg_match ( "@Geschrieben von (.*?) am (.*?):@", $messageSplitted[0] ) == 1 ) {
				unset ( $messageSplitted[0] );	
				$messageSplitted = array_values( $messageSplitted );		
			}
			if ( preg_match ( "@Geschrieben von (.*?) am (.*?):@", $messageSplitted[1] ) == 1 ) {
				unset ( $messageSplitted[1] );			
				$messageSplitted = array_values( $messageSplitted );
			}
			if ( preg_match ( "@Geschrieben von (.*?) am (.*?):@", $messageSplitted[2] ) == 1 ) {
				unset ( $messageSplitted[2] );			
				$messageSplitted = array_values( $messageSplitted );
			}
			if ( preg_match ( "@Als Antwort auf:(.*)geschrieben von (.*?) am (.*?):@", $messageSplitted[0] ) == 1 ) {
				unset ( $messageSplitted[0] );			
				$messageSplitted = array_values( $messageSplitted );
			}
			if ( preg_match ( "@Als Antwort auf:(.*)geschrieben von (.*?) am (.*?):@", $messageSplitted[1] ) == 1 ) {
				unset ( $messageSplitted[1] );
				$messageSplitted = array_values( $messageSplitted );
			}			
			if ( preg_match ( "@Als Antwort auf:(.*)geschrieben von (.*?) am (.*?):@", $messageSplitted[2] ) == 1 ) {
				unset ( $messageSplitted[2] );			
				$messageSplitted = array_values( $messageSplitted );
			}
			$matches[1] = trim ( implode ( "\n", $messageSplitted ) );
		} elseif ( strpos ( $file, "<!-- Anfang BeitragsText -->" ) !== false ) {
			echo $this->lastPosting+1 . ' will test format between BeitragsText!<br>';			
			preg_match('/<!-- Anfang BeitragsText -->(.*?)<!-- Ende BeitragsText -->/is', $file, $matches);
		} elseif ( strpos ( $file, '<input type=hidden name="body" value="' ) !== false ) {
			echo $this->lastPosting+1 . ' will test format from answer-form!<br>';
			preg_match('/<input type=hidden name="body" value="(.*?)">/is', $file, $matches);			
		} else {
			$this->alert ( 'Unknown format in file ' . $file_name . ' - please contact author!' );
		}
		$message_text = $matches[1];
		$message_text = str_replace(array("\r&gt;", "\r\n&gt;", "\n&gt;"), "\n", $message_text);
		//$message_text = substr ( $message_text, 4 );
		
		// remove all html commands
		$message_text = trim ( strip_tags($message_text) );

		$message_title = htmlentities($message_title);
		$message_text = htmlentities($message_text);
		
		// but keep some "good" friends
		$message_title = str_replace ( array ( '&amp;quot;'), array ( '&quot;'), $message_title);
		$message_text = str_replace ( array ( '&amp;quot;'), array ( '&quot;'), $message_text);
		
		if ( $this->debugMode ) {
			$message_text .= "\n\nbasierend auf " . $file_name;
		}
				
		//======== New Thread ===============
		if ( !isset ( $this->parentTopic[$origin_file_name] ) )
		{
			$topicID = $this->insertNewTopic($message_title, '', $postingTime );
			$this->insertedTopics++;
		} else {
			$topicID = $this->parentTopic[$origin_file_name];
		}
		//======== Reply ===============

		$this->insertPosting ( $topicID, $posterName, $message_title, $message_text, $postingTime );
		$this->insertedPosts++;

/*		echo "Thread Number: " . $this->insertedTopics . " / ID: " . $this->actualTopicID
		 . ", Post Number: ". $this->insertedPosts . " / ID: " . $this->lastPosting . "<br><br>";
		echo $message_title;
		echo "<br><br>";
		echo $message_sub_title;
		echo "<br>";
		echo $message_text;
		echo "<br><hr><br>";
*/		
		$this->deleteFileFromTasklist($origin_file_name);
	}
	
	function deleteFileFromTasklist ( $name ) {
		$newFilesToParse = array();
		foreach ( $this->filesToParse as $oldFile ) {
			if ( $oldFile != $name ) {
				$newFilesToParse[] = $oldFile;
			}
		}
		$this->filesToParse = $newFilesToParse;
		$this->postingsAlreadyAdded++;
		$this->outputProgress();
	}
	
	function convertToTimestamp ( $date ) {
		if ( $date[2] == '.' || $date[2] == ' ' ) {
			$day = substr ( $date, 0, 2 );
			$date = trim ( substr( $date, 3 ) );
		} elseif ( $date[1] == '.' ) {
			$day = substr ( $date, 0, 1 );
			$date = trim ( substr ( $date, 2 ) );
		} else {
			$day = 1;
			$date = trim ( $date );
		}
		$dateArray = explode ( " ", $date );
		
		$monatText = strtolower ( $dateArray[0] );
		switch ( $monatText ) {
			case 'januar':
			case 'january':
				$monatNumber = 1;
				break;
			case 'februar':
			case 'february':
				$monatNumber = 2;
				break;
			case 'mrz':
			case 'march':
				$monatNumber = 3;
				break;
			case 'april':
				$monatNumber = 4;
				break;
			case 'mai':
			case 'may':
				$monatNumber = 5;
				break;
			case 'juni':
			case 'june':
				$monatNumber = 6;
				break;
			case 'juli':
			case 'july':
				$monatNumber = 7;
				break;
			case 'august':
				$monatNumber = 8;
				break;
			case 'september':
				$monatNumber = 9;
				break;
			case 'oktober':
			case 'october':
				$monatNumber = 10;
				break;		
			case 'november':
				$monatNumber = 11;
				break;
			case 'dezember':
			case 'december':
				$monatNumber = 12;
				break;
			default:
				// check again mrz once more
				if ( substr ( $monatText, 0, 1 ) == 'm' && substr ( $monatText, -2 ) == 'rz' ) {
					$monatNumber = 3;
				} else {
					$this->alert ( 'Unknown month ' . $monatText . ' in ' . $this->actualParsedFile . ' - please contact the author!' );
				}
				break;
		}
		$year = $dateArray[1];
		if ( $year == 2099 ) {
			// There seem to be some errors in 1999s postings
			$year = 1999;
		}
		if ( $dateArray[2] == 'at' || $dateArray[2] == 'um' ) {
			// Hack for veeeeeery old pages that have an 'at' between year and time
			$dateArray[2] = $dateArray[3];
		}
		$time = explode ( ':', $dateArray[2] );
		$timestamp = mktime ( $time[0], $time[1], $time[2], $monatNumber, $day, $year );
		return $timestamp;
	}
	
	function insertPosting() {
		$this->alert ( "Error! Your plugin does not provide it's own insertPosting-function!" );
	}

	function insertNewTopic() {
		$this->alert ( "Error! Your plugin does not provide it's own insertNewTopic-function!" );
	}

	function outputProgress() {
		$output = floor ( $this->postingsAlreadyAdded / $this->postingsToAdd * 100 );
		$textOutput = $output . '% done (' . $this->postingsAlreadyAdded . ' of ' . $this->postingsToAdd . ' postings imported)';
		
		if ( $this->useXAJAX ) {
			return array($output, $textOutput);
		} else if ( $output != $this->lastOutput ) {
			$this->lastOutput = $output;
			echo $textOutput . '<br>';
			flush();				
		}
	}
	
	function generateQuote ( $message, $start = 'quote', $end = 'quote' ) {
		$messageArray = explode ( "\n", $message );
		$inQuote = false;
		$beforeQuoteArray = array();
		$quoteArray = array();
		$afterQuoteArray = array();
		foreach ( $messageArray as $singleLine ) {
			if ( substr ( $singleLine, 0, 4 ) == '&gt;' ) {
				$quoteArray[] = substr ( $singleLine, 4 );
				$inQuote = true;
			} elseif ( $inQuote ) {
				$afterQuoteArray[] = $singleLine;
			} else {
				$beforeQuoteArray[] = $singleLine;
			}
		}
		$messageReturn = '';
		if ( count ( $beforeQuoteArray ) > 0 ) {
			$messageReturn .= implode ( "\n", $beforeQuoteArray );
		}
		if ( count ( $quoteArray ) > 0 ) {
			$messageReturn .= '[' . $start . ']' . $this->generateQuote( implode ( "\n", $quoteArray ) ) . '[/' . $end . ']';
		}
		if ( count ( $afterQuoteArray ) > 0 ) {
			$messageReturn .= $this->generateQuote(implode ( "\n", $afterQuoteArray ) );
		}
		return $messageReturn;
	}	
	
	function everythingDone() {
		return ( $this->postingsToAdd == $this->postingsAlreadyAdded );
	}
	
	function finally() {
		// basic-function to call if lower class does not provide it
	}
	
	function alert ( $string ) {
		if ( $this->useXAJAX ) {
			$this->xajaxResponse->alert ( $string );
			$this->hasAlert = true;
		} else {
			die ( $string );
		}
	}
	
	function hasAlert() {
		return $this->hasAlert;
	}
	
	function getResponse() {
		return $this->xajaxResponse;
	}	

	function getAlert() {
		return $this->getResponse();
	}
	
	function output ( $string ) {
		if ( $this->useXAJAX ) {
			$this->xajaxResponse->alert ( $string );
		} else {
			echo ( $string );
		}		
	}
	
	function __wakeup() {
		$this->xajaxResponse = new xajaxResponse();
	}
	
	function __sleep() {
		return( array_keys( get_object_vars( &$this ) ) );
	}

}
?>
