<?php
/***************************************************************************
 * $Id: import.php 45 2008-03-28 23:53:48Z Nico $
 * Part of Parsimony Import
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

include_once ( 'phpbb2.class.php' );
include_once ( 'phpbb3.class.php' );
include_once ( 'smf1.class.php' );

/**
 * Kurzanleitung fr den Import von Parsimony-Foren
 * 
 * Mit diesem Importierer kann ein Parsimony-Forum in ein neues Forensystem
 * umgezogen werden. Ein Backup vor dem Start kann brigens nicht starten ;)
 * 
 * 
 * Bitte gib dann hier an, in welches Forensystem
 * du importieren mchtest. Aktuell stehen zur Verfgung:
 * phpBB2, phpBB3, SMF1
 */

$importTo = 'phpBB2';

/**
 * Dann muss das bei Parsimony erhltliche Zip-Archiv in einen
 * eigenen Ordner entpackt werden. Bei der Angabe der Ordner-
 * position ist es wichtig, Backslashes zu verdoppeln!
 */

$ordner = 'c:\\parsimony\\';

/**
 * Hier folgen dann die Zugangsdaten zur MySQL-Datenbank
 */

$host = 'localhost';
$database = 'phpbb';
$user = 'phpbb';
$password = 'phpbb';

/**
 * Und als letztes der in deinem Forensystem eingetragene Prfix
 * fr die Tabellen und die ID des Forums, in das die Daten
 * importiert werden sollen
 */

$prefix = 'phpbb_';
$forumID = 2;

/**
 * Nun kanns losgehen! Weitere, nicht zwingend ntige Einstellungen knnen unten
 * getroffen werden
 */


/**
 * Debugmodus aktivieren? Gibt alle SQL-Queries aus
 */
$debug = false;

/**
 * Leeren der vorhandenen Daten vor dem Import?
 * ACHTUNG! Tdlich fr ein bestehendes Forum! Vorher definitiv ein
 * Backup speichern!
 */
$truncate = false;

/**
 * useXAJAX ist immer false, da hier nicht die neue GUI benutzt wird
 */
$useXAJAX = false;

// Hier gehts nun los!

switch ( $importTo ) {
	case 'phpBB2':
		$importKlasse = new phpBB2Import( $ordner, $host, $user, $password, $database, $forumID, $prefix, $useXAJAX, $debug );
		break;
	case 'phpBB3':
		$importKlasse = new phpBB3Import( $ordner, $host, $user, $password, $database, $forumID, $prefix, $useXAJAX, $debug );
		break;
	case 'SMF1':
		$importKlasse = new SMF1Import( $ordner, $host, $user, $password, $database, $forumID, $prefix, $useXAJAX, $debug );
		break;
	default:
		die ( 'Unknown destination ' . $importTo );		
}

// Schnellzugriff fuer Entwicklungszwecke:
// $importKlasse = new phpBB2Import( 'c:\\parsimony\\', 'localhost', 'phpbb', 'phpbb', 'phpbb', 2, 'phpbb_', false, false ); $truncate = true;
// $importKlasse = new phpBB3Import( 'c:\\parsimony\\', 'localhost', 'phpbb', 'phpbb', 'phpbb', 2, 'phpbb3_', false, false ); $truncate = true;
// $importKlasse = new SMF1Import( 'c:\\parsimony\\', 'localhost', 'smf', 'smf', 'smf', 3, 'smf_', false, false ); $truncate = true;

if ( $debug && $truncate ) {
	$importKlasse->prepareForDebug(); 
}

$importKlasse->doImport();
?>

Queries: <?php echo $importKlasse->database->sql_Count(); ?>